use crate::prelude::*;

// use super::super::super::shared::light::LightParameter;

use super::RasterizerLightInterface;
use anyhow::Result;
use utilities::impl_reprc;

use std::{
    marker::PhantomData,
    sync::{Arc, Mutex},
};

impl_reprc!(
    pub struct ExtendedSpotLightData {
        #[assume_reprc]
        dummy: PhantomData<()>,
    }
);

pub struct SpotLight {
    light_data: Light,
}

impl RasterizerLightInterface<ExtendedSpotLightData> for SpotLight {
    fn shadow_map(&self) -> &Arc<Image> {
        todo!()
    }

    fn buffer(&self) -> &Arc<Buffer<ExtendedSpotLightData>> {
        todo!()
    }

    fn invalidate(&mut self) {}

    fn new(
        _light: Light,
        _device: &Arc<Device>,
        _queue: &Arc<Mutex<Queue>>,
        _image_count: usize,
        _shadow_image_size: u32,
    ) -> Result<Self> {
        todo!()
    }

    fn render(
        &mut self,
        _content: &Vec<&EntityObject>,
        _buffer_recorder: &mut CommandBufferRecorder<'_>,
        _index: usize,
    ) -> Result<()> {
        todo!()
    }

    fn set_center(&mut self, _center: cgmath::Vector3<f32>) -> Result<()> {
        todo!()
    }

    fn eq(&self, light: &Light) -> bool {
        self.light_data.eq(light)
    }
}

impl Drop for SpotLight {
    fn drop(&mut self) {
        self.light_data.clear_update_callback();
    }
}
